#include <cstdio>
#include <cstring>
#include <cmath>
#include <ctime>

#include "Edge.h"
#include "Mesh.h"
#include "Geometry.h"

namespace bamg {

	/*Constructors/Destructors*/

	/*Methods*/
	/*FUNCTION Edge::Set {{{1*/
	void Edge::Set(const Mesh & Th ,long i,Mesh & ThNew){ 
		*this = Th.edges[i];
		v[0] = ThNew.vertices + Th.Number(v[0]);    
		v[1] = ThNew.vertices + Th.Number(v[1]);
		if (onGeometry) 
		 onGeometry =  ThNew.Gh.edges+Th.Gh.Number(onGeometry);
		if (adj[0]) adj[0] =   ThNew.edges +   Th.Number(adj[0]);
		if (adj[1]) adj[1] =   ThNew.edges +   Th.Number(adj[1]);
	}
	/*}}}*/
	/*FUNCTION Edge::Echo {{{1*/
	void Edge::Echo(void){ 
		printf("Edge:\n");
		printf("   pointers towards two vertices: %p %p\n",v[0],v[1]);
		printf("   ref = %i\n",ref);
		printf("   onGeometry = %p\n",onGeometry);
		printf("   two adjacent edges on the same curve: %p %p\n",adj[0],adj[1]);
	}
	/*}}}*/
	/*FUNCTION Edge::Renumbering{{{1*/
	void Edge::Renumbering(BamgVertex *vb,BamgVertex *ve, long *renu){

		if (v[0] >=vb && v[0] <ve) v[0] = vb + renu[v[0]-vb];
		if (v[1] >=vb && v[1] <ve) v[1] = vb + renu[v[1]-vb];

	}
	/*}}}*/
	/*FUNCTION Edge::Intersection{{{1*/
	int Edge::Intersection(const  Edge & e){ 

		/*some shecks*/
		if (!(adj[0]==&e || adj[1]==&e)){ ISSMERROR("Intersection bug"); }
		ISSMASSERT(adj[0]==&e || adj[1]==&e);

		return adj[0]==&e?0:1;
	}
	/*}}}*/

} 
